//+------------------------------------------------------------------+
//|                                               DMI ADX histogram oscillator.mq4 |
//|                               Copyright  2012, Gehtsoft USA LLC |
//|                                            http://fxcodebase.com |
//|                                            mario.jemic@gmail.com |
//+------------------------------------------------------------------+
#property copyright "Copyright  2012, Gehtsoft USA LLC"
#property link      "http://fxcodebase.com"

#property indicator_separate_window
#property indicator_buffers 3
#property indicator_color1 Black
#property indicator_color2 Blue
#property indicator_color3 Red
#property indicator_width1 1
#property indicator_width2 15
#property indicator_width3 15
#property indicator_minimum -0.0001
#property indicator_maximum  0.0001


 
extern int CalculationPeriod=2;
extern int Mode=0;
extern bool Smoothing = true;
extern int PriceType=1;
extern bool alertsOn        = true;
extern bool alertsOnCurrent = true;
extern bool alertsMessage   = true;
extern bool alertsPushNotif = true;
extern bool alertsSound     = true;
extern bool alertsEmail     = true;

double ADX[];
double UP[];
double DOWN[];
double trend[];

int init()
  {
   IndicatorBuffers(4);
   IndicatorShortName("DMI ADX Filter");
   IndicatorDigits(Digits);
   SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ADX);
   
   
   SetIndexStyle(1,DRAW_HISTOGRAM);
   SetIndexBuffer(1,UP);
   
   SetIndexStyle(2,DRAW_HISTOGRAM);
   SetIndexBuffer(2,DOWN);
   SetIndexBuffer(3,trend);
   
 
   
   return(0);
  }

int deinit()
  {
   return(0);
  }

int start()
 {
   int counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
           int limit=MathMin(Bars-counted_bars,Bars-1);
    
	
   for(int i=limit; i>=0; i--)
   {
 
	   double DMI = iADX(NULL, 0, CalculationPeriod, PriceType, MODE_PLUSDI, i)- iADX(NULL, 0, CalculationPeriod, PriceType, MODE_MINUSDI, i);
      
       ADX[i] = iADX(NULL, 0, CalculationPeriod, PriceType, MODE_MAIN, i);
	   trend[i] = trend[i+1];
	   if (DMI>0) 
			   {
			   UP[i]= DMI;
			   DOWN[i]=  EMPTY_VALUE;
			   trend[i]=1;
			   }
			   else
			   {
			   DOWN[i]= DMI;
			   UP[i]=  EMPTY_VALUE;
			   trend[i]=-1;
			   }
   } 
   manageAlerts(); 
  
  
  
   
 return(0);
}

//-------------------------------------------------------------------
//                                                                  
//-------------------------------------------------------------------
//
//
//
//
//

void manageAlerts()
{
   if (alertsOn)
   {
      int whichBar = 1; if (alertsOnCurrent) whichBar = 0;
      if (trend[whichBar] != trend[whichBar+1])
      {
         if (trend[whichBar] ==  1) doAlert(whichBar,"UP UP UP UP UP 11");
         if (trend[whichBar] == -1) doAlert(whichBar,"DOWN DOWN DOWN 11");
      }         
   }
}

//
//
//
//
//

void doAlert(int forBar, string doWhat)
{
   static string   previousAlert="nothing";
   static datetime previousTime;
   string message;
   
   if (previousAlert != doWhat || previousTime != Time[forBar]) {
       previousAlert  = doWhat;
       previousTime   = Time[forBar];

       //
       //
       //
       //
       //

       message =  StringConcatenate(Symbol()," at ",TimeToStr(TimeLocal(),TIME_SECONDS)," DMI ADX signal ",doWhat);
          if (alertsMessage)   Alert(message);
          if (alertsEmail)     SendMail(StringConcatenate(Symbol()," DMI ADX"),message);
          if (alertsPushNotif) SendNotification(StringConcatenate(Symbol()," DMI ADX "+message));
          if (alertsSound)     PlaySound("alert2.wav");
   }
}